// plgsmpl2.cpp
//

#include "stdafx.h"
#include "plgsmpl2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPlgsmpl2App

BEGIN_MESSAGE_MAP(CPlgsmpl2App, CWinApp)
	//{{AFX_MSG_MAP(CPlgsmpl2App)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPlgsmpl2App

CPlgsmpl2App::CPlgsmpl2App()
{
}

CPlgsmpl2App theApp;

#include <string.h>
#include "mpplugin.h"
#include "resource.h"

#define PLUGIN_NAME_1 "Plugin Sample 1"
#define PLUGIN_NAME_2 "Plugin Sample 2"

PLUGGEDIN_EXPORT( long ) PLG_ExecuteCommand(PLUGGEDIN_STRUCT *ps)
{
	AFX_MANAGE_STATE( AfxGetStaticModuleState() );

	if (strcmp(ps->ps_pszFunction, PLUGIN_NAME_1) &&
		strcmp(ps->ps_pszFunction, PLUGIN_NAME_2) )
		return 0;

    char *buf=NULL;
    char *tmp1=NULL;
    char *path=NULL;
    int i;
    buf=new char[32+(MAX_PATH * ps->ps_nFiles)];
    tmp1=new char[MAX_PATH];
    path=new char[MAX_PATH];
    strcpy(buf,"Arg files:");
    for (i=0;i< ps->ps_nFiles; i++){
        strcat(buf," ");
        _splitpath(ps->ps_pszFiles[i],tmp1,tmp1,path,tmp1);
        strcat(buf, path);
    }
    AfxMessageBox(buf);
    
    delete buf;
    delete tmp1;
    delete path;
    return 1;
}

/* EnumerateCommands Entry */
PLUGGEDIN_EXPORT( long ) PLG_EnumerateCommands(char* pszEntries, long nBufSize, long* pnRealSize)
{
    *pnRealSize=strlen(PLUGIN_NAME_1)+1 
		        +strlen(PLUGIN_NAME_2)+1;

    if (nBufSize<*pnRealSize)
        return 0;

    strcpy(pszEntries, PLUGIN_NAME_1);
	strcpy(pszEntries+strlen(PLUGIN_NAME_1)+1,PLUGIN_NAME_2);
	return 1;
}

PLUGGEDIN_EXPORT( long ) PLG_Executable(const char *pszFunction, long nSel)
{
	return 1;
}
PLUGGEDIN_EXPORT( long ) PLG_RequireFiles(const char *pszFunction)
{
	return 1;
}

PLUGGEDIN_EXPORT( HICON ) PLG_GetCommandIcon(const char *pszFunction, long bNormal)
{
	AFX_MANAGE_STATE( AfxGetStaticModuleState() );
	HICON hIcon=NULL;
	unsigned resID=0;
	if (!strcmp(pszFunction, PLUGIN_NAME_1))
		resID= IDI_APPICON1;
	else if (!strcmp(pszFunction, PLUGIN_NAME_2))
		resID= IDI_APPICON2;
	else return 0;

	HINSTANCE myInst = (HINSTANCE) AfxGetInstanceHandle();
	if (bNormal)
		hIcon=LoadIcon(myInst,MAKEINTRESOURCE(resID));
	else
		hIcon=(HICON)LoadImage(myInst,MAKEINTRESOURCE(resID),IMAGE_ICON,16,16,0);
	return hIcon;
}


PLUGGEDIN_EXPORT( long ) PLG_Initialize(const char* cmd)
{
	return 1;
}

PLUGGEDIN_EXPORT( long ) PLG_Finalize(const char*  cmd)
{
	return 1;
}

PLUGGEDIN_EXPORT( long ) PLG_CanFinalize(const char*  cmd)
{
	return 1;
}

PLUGGEDIN_EXPORT( long ) PLG_IsParallel(const char *pszFunction)
{
	return 0;
}

PLUGGEDIN_EXPORT( long ) PLG_CanSetProfile(const char *pszFunction)
{
	return 1;
}

PLUGGEDIN_EXPORT( long ) PLG_SetProfile(const char *pszFunction)
{
	AFX_MANAGE_STATE( AfxGetStaticModuleState() );
	CAboutDlg dlg;
	dlg.DoModal();
	return 1;
}


PLUGGEDIN_EXPORT( long ) PLG_IsCloningCommand(const char *pszFunction)
{
    return 0;
}

PLUGGEDIN_EXPORT( long ) PLG_GetNewClone(char* pszNewClone, long bufsize)
{
    return 0;
}

PLUGGEDIN_EXPORT( long ) PLG_ReleaseClone(const char* pszClone)
{
    return 0;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg

CAboutDlg::CAboutDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAboutDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_strStat = _T("");
	//}}AFX_DATA_INIT
	m_strStat.LoadString(IDS_STRING1);
}


void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_STAT_EDIT, m_strStat);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

